#ifndef CONTROL_MANAGER_H
#define CONTROL_MANAGER_H

#include "HeaderControl.h"
#include "LocalControl.h"
#include "RemoteControl.h"
#include "TaskControl.h"
#include "LogControl.h"
#include "OnLineControl.h"
#include <memory>

class ClientCore;
class ControlManager
{
public:
    ControlManager(wxWindow* parent);
    ~ControlManager() = default;

public:
    void Init(std::shared_ptr<ClientCore>& clientCore);

private:
    wxWindow* parent_;

public:
    HeaderControl* header_;
    LocalControl* local_;
    RemoteControl* remote_;
    TaskControl* task_;
    LogControl* log_;
    OnlineControl* online_;
};

#endif   // CONTROL_MANAGER_H