#ifndef HEADERCONTROL_H
#define HEADERCONTROL_H

#include <wx/wx.h>
#include <memory>

class LogControl;
class ClientCore;
class OnlineControl;
class HeaderControl : public wxPanel
{
public:
    HeaderControl(wxWindow* parent, std::shared_ptr<ClientCore>& clientCore);
    ~HeaderControl() override;

public:
    void SetLogControl(LogControl* logControl);
    void SetOnlineControl(OnlineControl* onlineControl);

private:
    void Init();

private:
    void OnConnect(wxCommandEvent& event);
    void OnDisconnect(wxCommandEvent& event);

public:
    wxTextCtrl* textIP_;
    wxTextCtrl* textPort_;
    wxButton* btnConnect_;
    wxButton* btnDisconnect_;
    std::shared_ptr<ClientCore> clientCore_;

private:
    LogControl* logControl_;
    OnlineControl* onlineControl_;
};

#endif   // HEADERCONTROL_H